﻿using System;
using System.Collections.Generic;
using System.Collections;
using System.Linq;
using System.Data.Linq;
using System.Data.Linq.Mapping;
using System.Text;

using HeuristicLab.Services.Authentication.DataAccess;
using HeuristicLab.Services.Authentication.DataTransfer;
using HeuristicLab.Services.Authentication;
using DA = HeuristicLab.Services.Authentication.DataAccess;
using DT = HeuristicLab.Services.Authentication.DataTransfer;
using HLSA = HeuristicLab.Services.Authentication;


namespace HeuristicLab.Services.Authentication {

  public class ClientService : IClientService{


    private void RemoveRRGEntry(ClientManagmentDataContext cmdc, Guid resID) {
      foreach (var rrg in cmdc.ResourceResourceGroups.Where(x => x.ResourceId == resID))
        cmdc.ResourceResourceGroups.DeleteOnSubmit(rrg);
    }


    public DataTransfer.Client GetClient(Guid id) {
      throw new NotImplementedException();
    }

    public IEnumerable<DataTransfer.Client> GetClients() {
      throw new NotImplementedException();
    }

    public Guid AddClient(DataTransfer.Client dto) {
      throw new NotImplementedException();
    }

    public bool UpdateClient(DataTransfer.Client dto) {
      throw new NotImplementedException();
    }

    public bool DeleteClient(DataTransfer.Client dto) {
      using (ClientManagmentDataContext cmdc = new ClientManagmentDataContext()) {
        RemoveRRGEntry(cmdc, dto.ResourceID);
        DA.Resource entity = cmdc.Resources.FirstOrDefault(x => x.Id == dto.ResourceID);
        if (entity != null) {
          cmdc.Resources.DeleteOnSubmit(entity);
          cmdc.SubmitChanges();
          return true;
        }
        return false;
      }
    }

    public DataTransfer.ResourceGroup GetResourceGroup(Guid id) {
      throw new NotImplementedException();
    }

    public IEnumerable<DataTransfer.ResourceGroup> GetResourceGroups() {
      throw new NotImplementedException();
    }

    public Guid AddResourceGroup(DataTransfer.ResourceGroup dto) {
      throw new NotImplementedException();
    }

    public bool UpdateResourceGroup(DataTransfer.ResourceGroup dto) {
      throw new NotImplementedException();
    }

    public bool DeleteResourceGroup(DataTransfer.ResourceGroup id) {
      throw new NotImplementedException();
    }

    public IEnumerable<DataTransfer.Resource> GetMembers(Guid id) {
      throw new NotImplementedException();
    }

    public IEnumerable<DataTransfer.Resource> GetRootResources() {
      throw new NotImplementedException();
    }
  }
}